<?php

require_once( dirname(__file__) . '/inputs-class.php' );

if ( ! class_exists( 'Dovi42_Meta_Box_Input_Number') ) :

    class Dovi42_Meta_Box_Input_Number extends Dovi42_Meta_Box_Inputs  {

        var $options = array(
                'description' => 'Only numbers can be entered!',
                'decimal' => ',',
                'separator' => ' '
            );

        public function __construct($options)
        {
            parent::__construct($options);
            $this->js = array('number.js');
        }


        function setVisual() {
            
            if (!empty($this->value)) {
                if (!empty($this->options['decimal'])) {
                    $tmp = explode($this->options['decimal'], $this->value);
                    $tmp[0] = number_format($tmp[0], 0, '.', $this->options['separator']);
                    if (isset($tmp[1])) {
                        $tmp[1] = number_format($tmp[1], 0, '.', $this->options['separator']);
                        $this->value = $tmp[0] . $this->options['decimal'] . $tmp[1];
                    } else {
                        $this->value = $tmp[0];
                    }
                } else {
                    if (!empty($this->options['separator'])) {
                        $this->value = number_format($tmp[1], 0, '.', $this->options['separator']);
                    }
                }
            }
        }

        function render($post_id) {
            
            parent::render($post_id);

            $this->setVisual();
            
            $html = '<tr>' . "\r\n" . 
                    "\t" . '<td>' . "\r\n" . 
                    "\t\t" . '<label for="'.$this->options['id'].'">'.$this->options['label'].'</label>' . "\r\n" . 
                    "\t" . '</td>' . "\r\n" .
                    "\t" . '<td>' . "\r\n" . 
                    "\t\t" . '<input onkeyup="dovi42_cmb_checkNumberFormat(jQuery(this));" type="text" name="'.$this->options['meta_key'].'_'.$this->options['id'].'" value="'.$this->value.'" dec="'.$this->options['decimal'].'" sep="'.$this->options['separator'].'" data-type="number" />' . "\r\n";
            if ((isset($this->options['description'])) and (!empty($this->options['description']))) {
                    $html .= "\t\t" . '<div class="description small">'.$this->options['description'].'</div>' . "\r\n";
            } 
            
            $html .= "\t" . '</td>' . "\r\n" .
                     '</tr>' . "\r\n"; 
            return $html;
        }

        function sanitize() {

            parent::sanitize();
            $this->value = preg_replace('/(-)?+[^0-9'.$this->options['decimal'].']/','', $this->value);
        }

    }
endif;