<?php

function shift_schedule_698_get_users($day, $flag = null, $category = null) {
    global $wpdb;
 
    if (empty($flag)) {
        
        $options = shift_schedule_698_get_options();
        $types = array();
        $flags = array();
        foreach ($options['types'] as $type) {
            if ($type->free != 1) {
                $types[] = $type->alias;
                $flags[$type->alias] = $type->title;
            }
        }
    } else {
        $types = explode(',', $flag);
    }
    
    $table_name = $wpdb->prefix . 'shift_schedule';
    $where = array();

    if ($category != null) {

        $cats = str_replace(' ', '', $category);
        $cats = explode(',', $cats);
        $users = get_posts([
            'post_type' => 'schedule-user',
            'post_status' => 'publish',
            'posts_per_page' => -1,
            'tax_query' => array(
                array(
                    'taxonomy' => 'schedule-category',
                    'field' => 'slug',
                    'terms' => $cats,
                    'operator' => 'IN'
                ),
            )
        ]);  
        $where_users = array();
        foreach ($users as $user) {
            $where_users[] = $user->ID;    
        }          
        $where[] = '`user_id` IN ("'.implode('","', $where_users).'")';
    }

    $where[] = '`day` = "'.$day.'"';
    $where[] = '`flag` IN ("'.implode('","', $types).'")';
    
    $query = 'SELECT `user_id`, `flag` FROM `'.$table_name.'` ' .
             'WHERE ' .
                implode(' AND ', $where) .
                ' ORDER BY FIELD(flag, "'.implode('","', $types).'")';
    $data = $wpdb->get_results($query, ARRAY_A);

    
    return $data;
}

function shift_schedule_698_get_flag($alias) {
    $options = shift_schedule_698_get_options();
    $flag = new stdClass();
    $flag->title = '';
    $flag->color = '#ffffff';
    $flag->chars = '';
    
    foreach ($options['types'] as $type) {
        if ($type->alias == $alias) {
            return $type;
        }
    }
    return $flag;
}
